// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.6.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __ELASTICITY_H
#define __ELASTICITY_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Elasticity {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_0_0 = det*(g00*g00 + g01*g01 + g02*g02);
    real G0_0_1 = det*(g00*g10 + g01*g11 + g02*g12);
    real G0_0_2 = det*(g00*g20 + g01*g21 + g02*g22);
    real G0_1_0 = det*(g10*g00 + g11*g01 + g12*g02);
    real G0_1_1 = det*(g10*g10 + g11*g11 + g12*g12);
    real G0_1_2 = det*(g10*g20 + g11*g21 + g12*g22);
    real G0_2_0 = det*(g20*g00 + g21*g01 + g22*g02);
    real G0_2_1 = det*(g20*g10 + g21*g11 + g22*g12);
    real G0_2_2 = det*(g20*g20 + g21*g21 + g22*g22);
    real G1_0_0_0_0 = det*g00*g00;
    real G1_0_0_0_1 = det*g00*g10;
    real G1_0_0_0_2 = det*g00*g20;
    real G1_0_0_1_0 = det*g10*g00;
    real G1_0_0_1_1 = det*g10*g10;
    real G1_0_0_1_2 = det*g10*g20;
    real G1_0_0_2_0 = det*g20*g00;
    real G1_0_0_2_1 = det*g20*g10;
    real G1_0_0_2_2 = det*g20*g20;
    real G1_0_1_0_0 = det*g01*g00;
    real G1_0_1_0_1 = det*g01*g10;
    real G1_0_1_0_2 = det*g01*g20;
    real G1_0_1_1_0 = det*g11*g00;
    real G1_0_1_1_1 = det*g11*g10;
    real G1_0_1_1_2 = det*g11*g20;
    real G1_0_1_2_0 = det*g21*g00;
    real G1_0_1_2_1 = det*g21*g10;
    real G1_0_1_2_2 = det*g21*g20;
    real G1_0_2_0_0 = det*g02*g00;
    real G1_0_2_0_1 = det*g02*g10;
    real G1_0_2_0_2 = det*g02*g20;
    real G1_0_2_1_0 = det*g12*g00;
    real G1_0_2_1_1 = det*g12*g10;
    real G1_0_2_1_2 = det*g12*g20;
    real G1_0_2_2_0 = det*g22*g00;
    real G1_0_2_2_1 = det*g22*g10;
    real G1_0_2_2_2 = det*g22*g20;
    real G1_1_0_0_0 = det*g00*g01;
    real G1_1_0_0_1 = det*g00*g11;
    real G1_1_0_0_2 = det*g00*g21;
    real G1_1_0_1_0 = det*g10*g01;
    real G1_1_0_1_1 = det*g10*g11;
    real G1_1_0_1_2 = det*g10*g21;
    real G1_1_0_2_0 = det*g20*g01;
    real G1_1_0_2_1 = det*g20*g11;
    real G1_1_0_2_2 = det*g20*g21;
    real G1_1_1_0_0 = det*g01*g01;
    real G1_1_1_0_1 = det*g01*g11;
    real G1_1_1_0_2 = det*g01*g21;
    real G1_1_1_1_0 = det*g11*g01;
    real G1_1_1_1_1 = det*g11*g11;
    real G1_1_1_1_2 = det*g11*g21;
    real G1_1_1_2_0 = det*g21*g01;
    real G1_1_1_2_1 = det*g21*g11;
    real G1_1_1_2_2 = det*g21*g21;
    real G1_1_2_0_0 = det*g02*g01;
    real G1_1_2_0_1 = det*g02*g11;
    real G1_1_2_0_2 = det*g02*g21;
    real G1_1_2_1_0 = det*g12*g01;
    real G1_1_2_1_1 = det*g12*g11;
    real G1_1_2_1_2 = det*g12*g21;
    real G1_1_2_2_0 = det*g22*g01;
    real G1_1_2_2_1 = det*g22*g11;
    real G1_1_2_2_2 = det*g22*g21;
    real G1_2_0_0_0 = det*g00*g02;
    real G1_2_0_0_1 = det*g00*g12;
    real G1_2_0_0_2 = det*g00*g22;
    real G1_2_0_1_0 = det*g10*g02;
    real G1_2_0_1_1 = det*g10*g12;
    real G1_2_0_1_2 = det*g10*g22;
    real G1_2_0_2_0 = det*g20*g02;
    real G1_2_0_2_1 = det*g20*g12;
    real G1_2_0_2_2 = det*g20*g22;
    real G1_2_1_0_0 = det*g01*g02;
    real G1_2_1_0_1 = det*g01*g12;
    real G1_2_1_0_2 = det*g01*g22;
    real G1_2_1_1_0 = det*g11*g02;
    real G1_2_1_1_1 = det*g11*g12;
    real G1_2_1_1_2 = det*g11*g22;
    real G1_2_1_2_0 = det*g21*g02;
    real G1_2_1_2_1 = det*g21*g12;
    real G1_2_1_2_2 = det*g21*g22;
    real G1_2_2_0_0 = det*g02*g02;
    real G1_2_2_0_1 = det*g02*g12;
    real G1_2_2_0_2 = det*g02*g22;
    real G1_2_2_1_0 = det*g12*g02;
    real G1_2_2_1_1 = det*g12*g12;
    real G1_2_2_1_2 = det*g12*g22;
    real G1_2_2_2_0 = det*g22*g02;
    real G1_2_2_2_1 = det*g22*g12;
    real G1_2_2_2_2 = det*g22*g22;
    real G2_0_0_0_0 = det*g00*g00;
    real G2_0_0_0_1 = det*g00*g10;
    real G2_0_0_0_2 = det*g00*g20;
    real G2_0_0_1_0 = det*g10*g00;
    real G2_0_0_1_1 = det*g10*g10;
    real G2_0_0_1_2 = det*g10*g20;
    real G2_0_0_2_0 = det*g20*g00;
    real G2_0_0_2_1 = det*g20*g10;
    real G2_0_0_2_2 = det*g20*g20;
    real G2_0_1_0_0 = det*g00*g01;
    real G2_0_1_0_1 = det*g00*g11;
    real G2_0_1_0_2 = det*g00*g21;
    real G2_0_1_1_0 = det*g10*g01;
    real G2_0_1_1_1 = det*g10*g11;
    real G2_0_1_1_2 = det*g10*g21;
    real G2_0_1_2_0 = det*g20*g01;
    real G2_0_1_2_1 = det*g20*g11;
    real G2_0_1_2_2 = det*g20*g21;
    real G2_0_2_0_0 = det*g00*g02;
    real G2_0_2_0_1 = det*g00*g12;
    real G2_0_2_0_2 = det*g00*g22;
    real G2_0_2_1_0 = det*g10*g02;
    real G2_0_2_1_1 = det*g10*g12;
    real G2_0_2_1_2 = det*g10*g22;
    real G2_0_2_2_0 = det*g20*g02;
    real G2_0_2_2_1 = det*g20*g12;
    real G2_0_2_2_2 = det*g20*g22;
    real G2_1_0_0_0 = det*g01*g00;
    real G2_1_0_0_1 = det*g01*g10;
    real G2_1_0_0_2 = det*g01*g20;
    real G2_1_0_1_0 = det*g11*g00;
    real G2_1_0_1_1 = det*g11*g10;
    real G2_1_0_1_2 = det*g11*g20;
    real G2_1_0_2_0 = det*g21*g00;
    real G2_1_0_2_1 = det*g21*g10;
    real G2_1_0_2_2 = det*g21*g20;
    real G2_1_1_0_0 = det*g01*g01;
    real G2_1_1_0_1 = det*g01*g11;
    real G2_1_1_0_2 = det*g01*g21;
    real G2_1_1_1_0 = det*g11*g01;
    real G2_1_1_1_1 = det*g11*g11;
    real G2_1_1_1_2 = det*g11*g21;
    real G2_1_1_2_0 = det*g21*g01;
    real G2_1_1_2_1 = det*g21*g11;
    real G2_1_1_2_2 = det*g21*g21;
    real G2_1_2_0_0 = det*g01*g02;
    real G2_1_2_0_1 = det*g01*g12;
    real G2_1_2_0_2 = det*g01*g22;
    real G2_1_2_1_0 = det*g11*g02;
    real G2_1_2_1_1 = det*g11*g12;
    real G2_1_2_1_2 = det*g11*g22;
    real G2_1_2_2_0 = det*g21*g02;
    real G2_1_2_2_1 = det*g21*g12;
    real G2_1_2_2_2 = det*g21*g22;
    real G2_2_0_0_0 = det*g02*g00;
    real G2_2_0_0_1 = det*g02*g10;
    real G2_2_0_0_2 = det*g02*g20;
    real G2_2_0_1_0 = det*g12*g00;
    real G2_2_0_1_1 = det*g12*g10;
    real G2_2_0_1_2 = det*g12*g20;
    real G2_2_0_2_0 = det*g22*g00;
    real G2_2_0_2_1 = det*g22*g10;
    real G2_2_0_2_2 = det*g22*g20;
    real G2_2_1_0_0 = det*g02*g01;
    real G2_2_1_0_1 = det*g02*g11;
    real G2_2_1_0_2 = det*g02*g21;
    real G2_2_1_1_0 = det*g12*g01;
    real G2_2_1_1_1 = det*g12*g11;
    real G2_2_1_1_2 = det*g12*g21;
    real G2_2_1_2_0 = det*g22*g01;
    real G2_2_1_2_1 = det*g22*g11;
    real G2_2_1_2_2 = det*g22*g21;
    real G2_2_2_0_0 = det*g02*g02;
    real G2_2_2_0_1 = det*g02*g12;
    real G2_2_2_0_2 = det*g02*g22;
    real G2_2_2_1_0 = det*g12*g02;
    real G2_2_2_1_1 = det*g12*g12;
    real G2_2_2_1_2 = det*g12*g22;
    real G2_2_2_2_0 = det*g22*g02;
    real G2_2_2_2_1 = det*g22*g12;
    real G2_2_2_2_2 = det*g22*g22;
    real G3_0_0 = det*(g00*g00 + g01*g01 + g02*g02);
    real G3_0_1 = det*(g00*g10 + g01*g11 + g02*g12);
    real G3_0_2 = det*(g00*g20 + g01*g21 + g02*g22);
    real G3_1_0 = det*(g10*g00 + g11*g01 + g12*g02);
    real G3_1_1 = det*(g10*g10 + g11*g11 + g12*g12);
    real G3_1_2 = det*(g10*g20 + g11*g21 + g12*g22);
    real G3_2_0 = det*(g20*g00 + g21*g01 + g22*g02);
    real G3_2_1 = det*(g20*g10 + g21*g11 + g22*g12);
    real G3_2_2 = det*(g20*g20 + g21*g21 + g22*g22);

    // Compute element tensor
    block[0] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G0_0_1 + 1.666666666666664e-01*G0_0_2 + 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G0_1_1 + 1.666666666666664e-01*G0_1_2 + 1.666666666666664e-01*G0_2_0 + 1.666666666666664e-01*G0_2_1 + 1.666666666666664e-01*G0_2_2 + 1.666666666666665e-01*G1_0_0_0_0 + 1.666666666666665e-01*G1_0_0_0_1 + 1.666666666666664e-01*G1_0_0_0_2 + 1.666666666666665e-01*G1_0_0_1_0 + 1.666666666666665e-01*G1_0_0_1_1 + 1.666666666666664e-01*G1_0_0_1_2 + 1.666666666666664e-01*G1_0_0_2_0 + 1.666666666666664e-01*G1_0_0_2_1 + 1.666666666666664e-01*G1_0_0_2_2 + 1.666666666666665e-01*G2_0_0_0_0 + 1.666666666666665e-01*G2_0_0_0_1 + 1.666666666666664e-01*G2_0_0_0_2 + 1.666666666666665e-01*G2_0_0_1_0 + 1.666666666666665e-01*G2_0_0_1_1 + 1.666666666666664e-01*G2_0_0_1_2 + 1.666666666666664e-01*G2_0_0_2_0 + 1.666666666666664e-01*G2_0_0_2_1 + 1.666666666666664e-01*G2_0_0_2_2 + 1.666666666666665e-01*G3_0_0 + 1.666666666666665e-01*G3_0_1 + 1.666666666666664e-01*G3_0_2 + 1.666666666666665e-01*G3_1_0 + 1.666666666666665e-01*G3_1_1 + 1.666666666666664e-01*G3_1_2 + 1.666666666666664e-01*G3_2_0 + 1.666666666666664e-01*G3_2_1 + 1.666666666666664e-01*G3_2_2;
    block[1] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_0_1 - 1.666666666666664e-01*G0_0_2 - 1.666666666666665e-01*G1_0_0_0_0 - 1.666666666666665e-01*G1_0_0_0_1 - 1.666666666666664e-01*G1_0_0_0_2 - 1.666666666666665e-01*G2_0_0_0_0 - 1.666666666666665e-01*G2_0_0_0_1 - 1.666666666666664e-01*G2_0_0_0_2 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_0_1 - 1.666666666666664e-01*G3_0_2;
    block[2] = -1.666666666666665e-01*G0_1_0 - 1.666666666666665e-01*G0_1_1 - 1.666666666666664e-01*G0_1_2 - 1.666666666666665e-01*G1_0_0_1_0 - 1.666666666666665e-01*G1_0_0_1_1 - 1.666666666666664e-01*G1_0_0_1_2 - 1.666666666666665e-01*G2_0_0_1_0 - 1.666666666666665e-01*G2_0_0_1_1 - 1.666666666666664e-01*G2_0_0_1_2 - 1.666666666666665e-01*G3_1_0 - 1.666666666666665e-01*G3_1_1 - 1.666666666666664e-01*G3_1_2;
    block[3] = -1.666666666666665e-01*G0_2_0 - 1.666666666666665e-01*G0_2_1 - 1.666666666666664e-01*G0_2_2 - 1.666666666666665e-01*G1_0_0_2_0 - 1.666666666666665e-01*G1_0_0_2_1 - 1.666666666666664e-01*G1_0_0_2_2 - 1.666666666666665e-01*G2_0_0_2_0 - 1.666666666666665e-01*G2_0_0_2_1 - 1.666666666666664e-01*G2_0_0_2_2 - 1.666666666666665e-01*G3_2_0 - 1.666666666666665e-01*G3_2_1 - 1.666666666666664e-01*G3_2_2;
    block[4] = 1.666666666666665e-01*G1_1_0_0_0 + 1.666666666666665e-01*G1_1_0_0_1 + 1.666666666666664e-01*G1_1_0_0_2 + 1.666666666666665e-01*G1_1_0_1_0 + 1.666666666666665e-01*G1_1_0_1_1 + 1.666666666666664e-01*G1_1_0_1_2 + 1.666666666666665e-01*G1_1_0_2_0 + 1.666666666666665e-01*G1_1_0_2_1 + 1.666666666666664e-01*G1_1_0_2_2 + 1.666666666666665e-01*G2_0_1_0_0 + 1.666666666666665e-01*G2_0_1_0_1 + 1.666666666666664e-01*G2_0_1_0_2 + 1.666666666666665e-01*G2_0_1_1_0 + 1.666666666666665e-01*G2_0_1_1_1 + 1.666666666666664e-01*G2_0_1_1_2 + 1.666666666666665e-01*G2_0_1_2_0 + 1.666666666666665e-01*G2_0_1_2_1 + 1.666666666666664e-01*G2_0_1_2_2;
    block[5] = -1.666666666666665e-01*G1_1_0_0_0 - 1.666666666666665e-01*G1_1_0_0_1 - 1.666666666666664e-01*G1_1_0_0_2 - 1.666666666666665e-01*G2_0_1_0_0 - 1.666666666666665e-01*G2_0_1_0_1 - 1.666666666666664e-01*G2_0_1_0_2;
    block[6] = -1.666666666666665e-01*G1_1_0_1_0 - 1.666666666666665e-01*G1_1_0_1_1 - 1.666666666666664e-01*G1_1_0_1_2 - 1.666666666666665e-01*G2_0_1_1_0 - 1.666666666666665e-01*G2_0_1_1_1 - 1.666666666666664e-01*G2_0_1_1_2;
    block[7] = -1.666666666666665e-01*G1_1_0_2_0 - 1.666666666666665e-01*G1_1_0_2_1 - 1.666666666666664e-01*G1_1_0_2_2 - 1.666666666666665e-01*G2_0_1_2_0 - 1.666666666666665e-01*G2_0_1_2_1 - 1.666666666666664e-01*G2_0_1_2_2;
    block[8] = 1.666666666666665e-01*G1_2_0_0_0 + 1.666666666666665e-01*G1_2_0_0_1 + 1.666666666666664e-01*G1_2_0_0_2 + 1.666666666666665e-01*G1_2_0_1_0 + 1.666666666666665e-01*G1_2_0_1_1 + 1.666666666666664e-01*G1_2_0_1_2 + 1.666666666666665e-01*G1_2_0_2_0 + 1.666666666666665e-01*G1_2_0_2_1 + 1.666666666666664e-01*G1_2_0_2_2 + 1.666666666666665e-01*G2_0_2_0_0 + 1.666666666666665e-01*G2_0_2_0_1 + 1.666666666666664e-01*G2_0_2_0_2 + 1.666666666666665e-01*G2_0_2_1_0 + 1.666666666666665e-01*G2_0_2_1_1 + 1.666666666666664e-01*G2_0_2_1_2 + 1.666666666666665e-01*G2_0_2_2_0 + 1.666666666666665e-01*G2_0_2_2_1 + 1.666666666666664e-01*G2_0_2_2_2;
    block[9] = -1.666666666666665e-01*G1_2_0_0_0 - 1.666666666666665e-01*G1_2_0_0_1 - 1.666666666666664e-01*G1_2_0_0_2 - 1.666666666666665e-01*G2_0_2_0_0 - 1.666666666666665e-01*G2_0_2_0_1 - 1.666666666666664e-01*G2_0_2_0_2;
    block[10] = -1.666666666666665e-01*G1_2_0_1_0 - 1.666666666666665e-01*G1_2_0_1_1 - 1.666666666666664e-01*G1_2_0_1_2 - 1.666666666666665e-01*G2_0_2_1_0 - 1.666666666666665e-01*G2_0_2_1_1 - 1.666666666666664e-01*G2_0_2_1_2;
    block[11] = -1.666666666666665e-01*G1_2_0_2_0 - 1.666666666666665e-01*G1_2_0_2_1 - 1.666666666666664e-01*G1_2_0_2_2 - 1.666666666666665e-01*G2_0_2_2_0 - 1.666666666666665e-01*G2_0_2_2_1 - 1.666666666666664e-01*G2_0_2_2_2;
    block[12] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_1_0 - 1.666666666666664e-01*G0_2_0 - 1.666666666666665e-01*G1_0_0_0_0 - 1.666666666666665e-01*G1_0_0_1_0 - 1.666666666666664e-01*G1_0_0_2_0 - 1.666666666666665e-01*G2_0_0_0_0 - 1.666666666666665e-01*G2_0_0_1_0 - 1.666666666666664e-01*G2_0_0_2_0 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_1_0 - 1.666666666666664e-01*G3_2_0;
    block[13] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G1_0_0_0_0 + 1.666666666666665e-01*G2_0_0_0_0 + 1.666666666666665e-01*G3_0_0;
    block[14] = 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G1_0_0_1_0 + 1.666666666666665e-01*G2_0_0_1_0 + 1.666666666666665e-01*G3_1_0;
    block[15] = 1.666666666666665e-01*G0_2_0 + 1.666666666666665e-01*G1_0_0_2_0 + 1.666666666666665e-01*G2_0_0_2_0 + 1.666666666666665e-01*G3_2_0;
    block[16] = -1.666666666666665e-01*G1_1_0_0_0 - 1.666666666666665e-01*G1_1_0_1_0 - 1.666666666666665e-01*G1_1_0_2_0 - 1.666666666666665e-01*G2_0_1_0_0 - 1.666666666666665e-01*G2_0_1_1_0 - 1.666666666666665e-01*G2_0_1_2_0;
    block[17] = 1.666666666666665e-01*G1_1_0_0_0 + 1.666666666666665e-01*G2_0_1_0_0;
    block[18] = 1.666666666666665e-01*G1_1_0_1_0 + 1.666666666666665e-01*G2_0_1_1_0;
    block[19] = 1.666666666666665e-01*G1_1_0_2_0 + 1.666666666666665e-01*G2_0_1_2_0;
    block[20] = -1.666666666666665e-01*G1_2_0_0_0 - 1.666666666666665e-01*G1_2_0_1_0 - 1.666666666666665e-01*G1_2_0_2_0 - 1.666666666666665e-01*G2_0_2_0_0 - 1.666666666666665e-01*G2_0_2_1_0 - 1.666666666666665e-01*G2_0_2_2_0;
    block[21] = 1.666666666666665e-01*G1_2_0_0_0 + 1.666666666666665e-01*G2_0_2_0_0;
    block[22] = 1.666666666666665e-01*G1_2_0_1_0 + 1.666666666666665e-01*G2_0_2_1_0;
    block[23] = 1.666666666666665e-01*G1_2_0_2_0 + 1.666666666666665e-01*G2_0_2_2_0;
    block[24] = -1.666666666666665e-01*G0_0_1 - 1.666666666666665e-01*G0_1_1 - 1.666666666666664e-01*G0_2_1 - 1.666666666666665e-01*G1_0_0_0_1 - 1.666666666666665e-01*G1_0_0_1_1 - 1.666666666666664e-01*G1_0_0_2_1 - 1.666666666666665e-01*G2_0_0_0_1 - 1.666666666666665e-01*G2_0_0_1_1 - 1.666666666666664e-01*G2_0_0_2_1 - 1.666666666666665e-01*G3_0_1 - 1.666666666666665e-01*G3_1_1 - 1.666666666666664e-01*G3_2_1;
    block[25] = 1.666666666666665e-01*G0_0_1 + 1.666666666666665e-01*G1_0_0_0_1 + 1.666666666666665e-01*G2_0_0_0_1 + 1.666666666666665e-01*G3_0_1;
    block[26] = 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G1_0_0_1_1 + 1.666666666666665e-01*G2_0_0_1_1 + 1.666666666666665e-01*G3_1_1;
    block[27] = 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G1_0_0_2_1 + 1.666666666666665e-01*G2_0_0_2_1 + 1.666666666666665e-01*G3_2_1;
    block[28] = -1.666666666666665e-01*G1_1_0_0_1 - 1.666666666666665e-01*G1_1_0_1_1 - 1.666666666666665e-01*G1_1_0_2_1 - 1.666666666666665e-01*G2_0_1_0_1 - 1.666666666666665e-01*G2_0_1_1_1 - 1.666666666666665e-01*G2_0_1_2_1;
    block[29] = 1.666666666666665e-01*G1_1_0_0_1 + 1.666666666666665e-01*G2_0_1_0_1;
    block[30] = 1.666666666666665e-01*G1_1_0_1_1 + 1.666666666666665e-01*G2_0_1_1_1;
    block[31] = 1.666666666666665e-01*G1_1_0_2_1 + 1.666666666666665e-01*G2_0_1_2_1;
    block[32] = -1.666666666666665e-01*G1_2_0_0_1 - 1.666666666666665e-01*G1_2_0_1_1 - 1.666666666666665e-01*G1_2_0_2_1 - 1.666666666666665e-01*G2_0_2_0_1 - 1.666666666666665e-01*G2_0_2_1_1 - 1.666666666666665e-01*G2_0_2_2_1;
    block[33] = 1.666666666666665e-01*G1_2_0_0_1 + 1.666666666666665e-01*G2_0_2_0_1;
    block[34] = 1.666666666666665e-01*G1_2_0_1_1 + 1.666666666666665e-01*G2_0_2_1_1;
    block[35] = 1.666666666666665e-01*G1_2_0_2_1 + 1.666666666666665e-01*G2_0_2_2_1;
    block[36] = -1.666666666666665e-01*G0_0_2 - 1.666666666666665e-01*G0_1_2 - 1.666666666666664e-01*G0_2_2 - 1.666666666666665e-01*G1_0_0_0_2 - 1.666666666666665e-01*G1_0_0_1_2 - 1.666666666666664e-01*G1_0_0_2_2 - 1.666666666666665e-01*G2_0_0_0_2 - 1.666666666666665e-01*G2_0_0_1_2 - 1.666666666666664e-01*G2_0_0_2_2 - 1.666666666666665e-01*G3_0_2 - 1.666666666666665e-01*G3_1_2 - 1.666666666666664e-01*G3_2_2;
    block[37] = 1.666666666666665e-01*G0_0_2 + 1.666666666666665e-01*G1_0_0_0_2 + 1.666666666666665e-01*G2_0_0_0_2 + 1.666666666666665e-01*G3_0_2;
    block[38] = 1.666666666666665e-01*G0_1_2 + 1.666666666666665e-01*G1_0_0_1_2 + 1.666666666666665e-01*G2_0_0_1_2 + 1.666666666666665e-01*G3_1_2;
    block[39] = 1.666666666666665e-01*G0_2_2 + 1.666666666666665e-01*G1_0_0_2_2 + 1.666666666666665e-01*G2_0_0_2_2 + 1.666666666666665e-01*G3_2_2;
    block[40] = -1.666666666666665e-01*G1_1_0_0_2 - 1.666666666666665e-01*G1_1_0_1_2 - 1.666666666666665e-01*G1_1_0_2_2 - 1.666666666666665e-01*G2_0_1_0_2 - 1.666666666666665e-01*G2_0_1_1_2 - 1.666666666666665e-01*G2_0_1_2_2;
    block[41] = 1.666666666666665e-01*G1_1_0_0_2 + 1.666666666666665e-01*G2_0_1_0_2;
    block[42] = 1.666666666666665e-01*G1_1_0_1_2 + 1.666666666666665e-01*G2_0_1_1_2;
    block[43] = 1.666666666666665e-01*G1_1_0_2_2 + 1.666666666666665e-01*G2_0_1_2_2;
    block[44] = -1.666666666666665e-01*G1_2_0_0_2 - 1.666666666666665e-01*G1_2_0_1_2 - 1.666666666666665e-01*G1_2_0_2_2 - 1.666666666666665e-01*G2_0_2_0_2 - 1.666666666666665e-01*G2_0_2_1_2 - 1.666666666666665e-01*G2_0_2_2_2;
    block[45] = 1.666666666666665e-01*G1_2_0_0_2 + 1.666666666666665e-01*G2_0_2_0_2;
    block[46] = 1.666666666666665e-01*G1_2_0_1_2 + 1.666666666666665e-01*G2_0_2_1_2;
    block[47] = 1.666666666666665e-01*G1_2_0_2_2 + 1.666666666666665e-01*G2_0_2_2_2;
    block[48] = 1.666666666666665e-01*G1_0_1_0_0 + 1.666666666666665e-01*G1_0_1_0_1 + 1.666666666666665e-01*G1_0_1_0_2 + 1.666666666666665e-01*G1_0_1_1_0 + 1.666666666666665e-01*G1_0_1_1_1 + 1.666666666666665e-01*G1_0_1_1_2 + 1.666666666666664e-01*G1_0_1_2_0 + 1.666666666666664e-01*G1_0_1_2_1 + 1.666666666666664e-01*G1_0_1_2_2 + 1.666666666666665e-01*G2_1_0_0_0 + 1.666666666666665e-01*G2_1_0_0_1 + 1.666666666666665e-01*G2_1_0_0_2 + 1.666666666666665e-01*G2_1_0_1_0 + 1.666666666666665e-01*G2_1_0_1_1 + 1.666666666666665e-01*G2_1_0_1_2 + 1.666666666666664e-01*G2_1_0_2_0 + 1.666666666666664e-01*G2_1_0_2_1 + 1.666666666666664e-01*G2_1_0_2_2;
    block[49] = -1.666666666666665e-01*G1_0_1_0_0 - 1.666666666666665e-01*G1_0_1_0_1 - 1.666666666666665e-01*G1_0_1_0_2 - 1.666666666666665e-01*G2_1_0_0_0 - 1.666666666666665e-01*G2_1_0_0_1 - 1.666666666666665e-01*G2_1_0_0_2;
    block[50] = -1.666666666666665e-01*G1_0_1_1_0 - 1.666666666666665e-01*G1_0_1_1_1 - 1.666666666666665e-01*G1_0_1_1_2 - 1.666666666666665e-01*G2_1_0_1_0 - 1.666666666666665e-01*G2_1_0_1_1 - 1.666666666666665e-01*G2_1_0_1_2;
    block[51] = -1.666666666666665e-01*G1_0_1_2_0 - 1.666666666666665e-01*G1_0_1_2_1 - 1.666666666666665e-01*G1_0_1_2_2 - 1.666666666666665e-01*G2_1_0_2_0 - 1.666666666666665e-01*G2_1_0_2_1 - 1.666666666666665e-01*G2_1_0_2_2;
    block[52] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G0_0_1 + 1.666666666666665e-01*G0_0_2 + 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G0_1_2 + 1.666666666666665e-01*G0_2_0 + 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G0_2_2 + 1.666666666666665e-01*G1_1_1_0_0 + 1.666666666666665e-01*G1_1_1_0_1 + 1.666666666666665e-01*G1_1_1_0_2 + 1.666666666666665e-01*G1_1_1_1_0 + 1.666666666666665e-01*G1_1_1_1_1 + 1.666666666666665e-01*G1_1_1_1_2 + 1.666666666666665e-01*G1_1_1_2_0 + 1.666666666666665e-01*G1_1_1_2_1 + 1.666666666666665e-01*G1_1_1_2_2 + 1.666666666666665e-01*G2_1_1_0_0 + 1.666666666666665e-01*G2_1_1_0_1 + 1.666666666666665e-01*G2_1_1_0_2 + 1.666666666666665e-01*G2_1_1_1_0 + 1.666666666666665e-01*G2_1_1_1_1 + 1.666666666666665e-01*G2_1_1_1_2 + 1.666666666666665e-01*G2_1_1_2_0 + 1.666666666666665e-01*G2_1_1_2_1 + 1.666666666666665e-01*G2_1_1_2_2 + 1.666666666666665e-01*G3_0_0 + 1.666666666666665e-01*G3_0_1 + 1.666666666666665e-01*G3_0_2 + 1.666666666666665e-01*G3_1_0 + 1.666666666666665e-01*G3_1_1 + 1.666666666666665e-01*G3_1_2 + 1.666666666666665e-01*G3_2_0 + 1.666666666666665e-01*G3_2_1 + 1.666666666666665e-01*G3_2_2;
    block[53] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_0_1 - 1.666666666666665e-01*G0_0_2 - 1.666666666666665e-01*G1_1_1_0_0 - 1.666666666666665e-01*G1_1_1_0_1 - 1.666666666666665e-01*G1_1_1_0_2 - 1.666666666666665e-01*G2_1_1_0_0 - 1.666666666666665e-01*G2_1_1_0_1 - 1.666666666666665e-01*G2_1_1_0_2 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_0_1 - 1.666666666666665e-01*G3_0_2;
    block[54] = -1.666666666666665e-01*G0_1_0 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G1_1_1_1_0 - 1.666666666666665e-01*G1_1_1_1_1 - 1.666666666666665e-01*G1_1_1_1_2 - 1.666666666666665e-01*G2_1_1_1_0 - 1.666666666666665e-01*G2_1_1_1_1 - 1.666666666666665e-01*G2_1_1_1_2 - 1.666666666666665e-01*G3_1_0 - 1.666666666666665e-01*G3_1_1 - 1.666666666666665e-01*G3_1_2;
    block[55] = -1.666666666666665e-01*G0_2_0 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G0_2_2 - 1.666666666666665e-01*G1_1_1_2_0 - 1.666666666666665e-01*G1_1_1_2_1 - 1.666666666666665e-01*G1_1_1_2_2 - 1.666666666666665e-01*G2_1_1_2_0 - 1.666666666666665e-01*G2_1_1_2_1 - 1.666666666666665e-01*G2_1_1_2_2 - 1.666666666666665e-01*G3_2_0 - 1.666666666666665e-01*G3_2_1 - 1.666666666666665e-01*G3_2_2;
    block[56] = 1.666666666666665e-01*G1_2_1_0_0 + 1.666666666666665e-01*G1_2_1_0_1 + 1.666666666666665e-01*G1_2_1_0_2 + 1.666666666666665e-01*G1_2_1_1_0 + 1.666666666666665e-01*G1_2_1_1_1 + 1.666666666666665e-01*G1_2_1_1_2 + 1.666666666666665e-01*G1_2_1_2_0 + 1.666666666666665e-01*G1_2_1_2_1 + 1.666666666666665e-01*G1_2_1_2_2 + 1.666666666666665e-01*G2_1_2_0_0 + 1.666666666666665e-01*G2_1_2_0_1 + 1.666666666666665e-01*G2_1_2_0_2 + 1.666666666666665e-01*G2_1_2_1_0 + 1.666666666666665e-01*G2_1_2_1_1 + 1.666666666666665e-01*G2_1_2_1_2 + 1.666666666666665e-01*G2_1_2_2_0 + 1.666666666666665e-01*G2_1_2_2_1 + 1.666666666666665e-01*G2_1_2_2_2;
    block[57] = -1.666666666666665e-01*G1_2_1_0_0 - 1.666666666666665e-01*G1_2_1_0_1 - 1.666666666666665e-01*G1_2_1_0_2 - 1.666666666666665e-01*G2_1_2_0_0 - 1.666666666666665e-01*G2_1_2_0_1 - 1.666666666666665e-01*G2_1_2_0_2;
    block[58] = -1.666666666666665e-01*G1_2_1_1_0 - 1.666666666666665e-01*G1_2_1_1_1 - 1.666666666666665e-01*G1_2_1_1_2 - 1.666666666666665e-01*G2_1_2_1_0 - 1.666666666666665e-01*G2_1_2_1_1 - 1.666666666666665e-01*G2_1_2_1_2;
    block[59] = -1.666666666666665e-01*G1_2_1_2_0 - 1.666666666666665e-01*G1_2_1_2_1 - 1.666666666666665e-01*G1_2_1_2_2 - 1.666666666666665e-01*G2_1_2_2_0 - 1.666666666666665e-01*G2_1_2_2_1 - 1.666666666666665e-01*G2_1_2_2_2;
    block[60] = -1.666666666666665e-01*G1_0_1_0_0 - 1.666666666666665e-01*G1_0_1_1_0 - 1.666666666666664e-01*G1_0_1_2_0 - 1.666666666666665e-01*G2_1_0_0_0 - 1.666666666666665e-01*G2_1_0_1_0 - 1.666666666666664e-01*G2_1_0_2_0;
    block[61] = 1.666666666666665e-01*G1_0_1_0_0 + 1.666666666666665e-01*G2_1_0_0_0;
    block[62] = 1.666666666666665e-01*G1_0_1_1_0 + 1.666666666666665e-01*G2_1_0_1_0;
    block[63] = 1.666666666666665e-01*G1_0_1_2_0 + 1.666666666666665e-01*G2_1_0_2_0;
    block[64] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_1_0 - 1.666666666666665e-01*G0_2_0 - 1.666666666666665e-01*G1_1_1_0_0 - 1.666666666666665e-01*G1_1_1_1_0 - 1.666666666666665e-01*G1_1_1_2_0 - 1.666666666666665e-01*G2_1_1_0_0 - 1.666666666666665e-01*G2_1_1_1_0 - 1.666666666666665e-01*G2_1_1_2_0 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_1_0 - 1.666666666666665e-01*G3_2_0;
    block[65] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G1_1_1_0_0 + 1.666666666666665e-01*G2_1_1_0_0 + 1.666666666666665e-01*G3_0_0;
    block[66] = 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G1_1_1_1_0 + 1.666666666666665e-01*G2_1_1_1_0 + 1.666666666666665e-01*G3_1_0;
    block[67] = 1.666666666666665e-01*G0_2_0 + 1.666666666666665e-01*G1_1_1_2_0 + 1.666666666666665e-01*G2_1_1_2_0 + 1.666666666666665e-01*G3_2_0;
    block[68] = -1.666666666666665e-01*G1_2_1_0_0 - 1.666666666666665e-01*G1_2_1_1_0 - 1.666666666666665e-01*G1_2_1_2_0 - 1.666666666666665e-01*G2_1_2_0_0 - 1.666666666666665e-01*G2_1_2_1_0 - 1.666666666666665e-01*G2_1_2_2_0;
    block[69] = 1.666666666666665e-01*G1_2_1_0_0 + 1.666666666666665e-01*G2_1_2_0_0;
    block[70] = 1.666666666666665e-01*G1_2_1_1_0 + 1.666666666666665e-01*G2_1_2_1_0;
    block[71] = 1.666666666666665e-01*G1_2_1_2_0 + 1.666666666666665e-01*G2_1_2_2_0;
    block[72] = -1.666666666666665e-01*G1_0_1_0_1 - 1.666666666666665e-01*G1_0_1_1_1 - 1.666666666666664e-01*G1_0_1_2_1 - 1.666666666666665e-01*G2_1_0_0_1 - 1.666666666666665e-01*G2_1_0_1_1 - 1.666666666666664e-01*G2_1_0_2_1;
    block[73] = 1.666666666666665e-01*G1_0_1_0_1 + 1.666666666666665e-01*G2_1_0_0_1;
    block[74] = 1.666666666666665e-01*G1_0_1_1_1 + 1.666666666666665e-01*G2_1_0_1_1;
    block[75] = 1.666666666666665e-01*G1_0_1_2_1 + 1.666666666666665e-01*G2_1_0_2_1;
    block[76] = -1.666666666666665e-01*G0_0_1 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G1_1_1_0_1 - 1.666666666666665e-01*G1_1_1_1_1 - 1.666666666666665e-01*G1_1_1_2_1 - 1.666666666666665e-01*G2_1_1_0_1 - 1.666666666666665e-01*G2_1_1_1_1 - 1.666666666666665e-01*G2_1_1_2_1 - 1.666666666666665e-01*G3_0_1 - 1.666666666666665e-01*G3_1_1 - 1.666666666666665e-01*G3_2_1;
    block[77] = 1.666666666666665e-01*G0_0_1 + 1.666666666666665e-01*G1_1_1_0_1 + 1.666666666666665e-01*G2_1_1_0_1 + 1.666666666666665e-01*G3_0_1;
    block[78] = 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G1_1_1_1_1 + 1.666666666666665e-01*G2_1_1_1_1 + 1.666666666666665e-01*G3_1_1;
    block[79] = 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G1_1_1_2_1 + 1.666666666666665e-01*G2_1_1_2_1 + 1.666666666666665e-01*G3_2_1;
    block[80] = -1.666666666666665e-01*G1_2_1_0_1 - 1.666666666666665e-01*G1_2_1_1_1 - 1.666666666666665e-01*G1_2_1_2_1 - 1.666666666666665e-01*G2_1_2_0_1 - 1.666666666666665e-01*G2_1_2_1_1 - 1.666666666666665e-01*G2_1_2_2_1;
    block[81] = 1.666666666666665e-01*G1_2_1_0_1 + 1.666666666666665e-01*G2_1_2_0_1;
    block[82] = 1.666666666666665e-01*G1_2_1_1_1 + 1.666666666666665e-01*G2_1_2_1_1;
    block[83] = 1.666666666666665e-01*G1_2_1_2_1 + 1.666666666666665e-01*G2_1_2_2_1;
    block[84] = -1.666666666666665e-01*G1_0_1_0_2 - 1.666666666666665e-01*G1_0_1_1_2 - 1.666666666666664e-01*G1_0_1_2_2 - 1.666666666666665e-01*G2_1_0_0_2 - 1.666666666666665e-01*G2_1_0_1_2 - 1.666666666666664e-01*G2_1_0_2_2;
    block[85] = 1.666666666666665e-01*G1_0_1_0_2 + 1.666666666666665e-01*G2_1_0_0_2;
    block[86] = 1.666666666666665e-01*G1_0_1_1_2 + 1.666666666666665e-01*G2_1_0_1_2;
    block[87] = 1.666666666666665e-01*G1_0_1_2_2 + 1.666666666666665e-01*G2_1_0_2_2;
    block[88] = -1.666666666666665e-01*G0_0_2 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G0_2_2 - 1.666666666666665e-01*G1_1_1_0_2 - 1.666666666666665e-01*G1_1_1_1_2 - 1.666666666666665e-01*G1_1_1_2_2 - 1.666666666666665e-01*G2_1_1_0_2 - 1.666666666666665e-01*G2_1_1_1_2 - 1.666666666666665e-01*G2_1_1_2_2 - 1.666666666666665e-01*G3_0_2 - 1.666666666666665e-01*G3_1_2 - 1.666666666666665e-01*G3_2_2;
    block[89] = 1.666666666666665e-01*G0_0_2 + 1.666666666666665e-01*G1_1_1_0_2 + 1.666666666666665e-01*G2_1_1_0_2 + 1.666666666666665e-01*G3_0_2;
    block[90] = 1.666666666666665e-01*G0_1_2 + 1.666666666666665e-01*G1_1_1_1_2 + 1.666666666666665e-01*G2_1_1_1_2 + 1.666666666666665e-01*G3_1_2;
    block[91] = 1.666666666666665e-01*G0_2_2 + 1.666666666666665e-01*G1_1_1_2_2 + 1.666666666666665e-01*G2_1_1_2_2 + 1.666666666666665e-01*G3_2_2;
    block[92] = -1.666666666666665e-01*G1_2_1_0_2 - 1.666666666666665e-01*G1_2_1_1_2 - 1.666666666666665e-01*G1_2_1_2_2 - 1.666666666666665e-01*G2_1_2_0_2 - 1.666666666666665e-01*G2_1_2_1_2 - 1.666666666666665e-01*G2_1_2_2_2;
    block[93] = 1.666666666666665e-01*G1_2_1_0_2 + 1.666666666666665e-01*G2_1_2_0_2;
    block[94] = 1.666666666666665e-01*G1_2_1_1_2 + 1.666666666666665e-01*G2_1_2_1_2;
    block[95] = 1.666666666666665e-01*G1_2_1_2_2 + 1.666666666666665e-01*G2_1_2_2_2;
    block[96] = 1.666666666666665e-01*G1_0_2_0_0 + 1.666666666666665e-01*G1_0_2_0_1 + 1.666666666666665e-01*G1_0_2_0_2 + 1.666666666666665e-01*G1_0_2_1_0 + 1.666666666666665e-01*G1_0_2_1_1 + 1.666666666666665e-01*G1_0_2_1_2 + 1.666666666666664e-01*G1_0_2_2_0 + 1.666666666666664e-01*G1_0_2_2_1 + 1.666666666666664e-01*G1_0_2_2_2 + 1.666666666666665e-01*G2_2_0_0_0 + 1.666666666666665e-01*G2_2_0_0_1 + 1.666666666666665e-01*G2_2_0_0_2 + 1.666666666666665e-01*G2_2_0_1_0 + 1.666666666666665e-01*G2_2_0_1_1 + 1.666666666666665e-01*G2_2_0_1_2 + 1.666666666666664e-01*G2_2_0_2_0 + 1.666666666666664e-01*G2_2_0_2_1 + 1.666666666666664e-01*G2_2_0_2_2;
    block[97] = -1.666666666666665e-01*G1_0_2_0_0 - 1.666666666666665e-01*G1_0_2_0_1 - 1.666666666666665e-01*G1_0_2_0_2 - 1.666666666666665e-01*G2_2_0_0_0 - 1.666666666666665e-01*G2_2_0_0_1 - 1.666666666666665e-01*G2_2_0_0_2;
    block[98] = -1.666666666666665e-01*G1_0_2_1_0 - 1.666666666666665e-01*G1_0_2_1_1 - 1.666666666666665e-01*G1_0_2_1_2 - 1.666666666666665e-01*G2_2_0_1_0 - 1.666666666666665e-01*G2_2_0_1_1 - 1.666666666666665e-01*G2_2_0_1_2;
    block[99] = -1.666666666666665e-01*G1_0_2_2_0 - 1.666666666666665e-01*G1_0_2_2_1 - 1.666666666666665e-01*G1_0_2_2_2 - 1.666666666666665e-01*G2_2_0_2_0 - 1.666666666666665e-01*G2_2_0_2_1 - 1.666666666666665e-01*G2_2_0_2_2;
    block[100] = 1.666666666666665e-01*G1_1_2_0_0 + 1.666666666666665e-01*G1_1_2_0_1 + 1.666666666666665e-01*G1_1_2_0_2 + 1.666666666666665e-01*G1_1_2_1_0 + 1.666666666666665e-01*G1_1_2_1_1 + 1.666666666666665e-01*G1_1_2_1_2 + 1.666666666666665e-01*G1_1_2_2_0 + 1.666666666666665e-01*G1_1_2_2_1 + 1.666666666666665e-01*G1_1_2_2_2 + 1.666666666666665e-01*G2_2_1_0_0 + 1.666666666666665e-01*G2_2_1_0_1 + 1.666666666666665e-01*G2_2_1_0_2 + 1.666666666666665e-01*G2_2_1_1_0 + 1.666666666666665e-01*G2_2_1_1_1 + 1.666666666666665e-01*G2_2_1_1_2 + 1.666666666666665e-01*G2_2_1_2_0 + 1.666666666666665e-01*G2_2_1_2_1 + 1.666666666666665e-01*G2_2_1_2_2;
    block[101] = -1.666666666666665e-01*G1_1_2_0_0 - 1.666666666666665e-01*G1_1_2_0_1 - 1.666666666666665e-01*G1_1_2_0_2 - 1.666666666666665e-01*G2_2_1_0_0 - 1.666666666666665e-01*G2_2_1_0_1 - 1.666666666666665e-01*G2_2_1_0_2;
    block[102] = -1.666666666666665e-01*G1_1_2_1_0 - 1.666666666666665e-01*G1_1_2_1_1 - 1.666666666666665e-01*G1_1_2_1_2 - 1.666666666666665e-01*G2_2_1_1_0 - 1.666666666666665e-01*G2_2_1_1_1 - 1.666666666666665e-01*G2_2_1_1_2;
    block[103] = -1.666666666666665e-01*G1_1_2_2_0 - 1.666666666666665e-01*G1_1_2_2_1 - 1.666666666666665e-01*G1_1_2_2_2 - 1.666666666666665e-01*G2_2_1_2_0 - 1.666666666666665e-01*G2_2_1_2_1 - 1.666666666666665e-01*G2_2_1_2_2;
    block[104] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G0_0_1 + 1.666666666666665e-01*G0_0_2 + 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G0_1_2 + 1.666666666666665e-01*G0_2_0 + 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G0_2_2 + 1.666666666666665e-01*G1_2_2_0_0 + 1.666666666666665e-01*G1_2_2_0_1 + 1.666666666666665e-01*G1_2_2_0_2 + 1.666666666666665e-01*G1_2_2_1_0 + 1.666666666666665e-01*G1_2_2_1_1 + 1.666666666666665e-01*G1_2_2_1_2 + 1.666666666666665e-01*G1_2_2_2_0 + 1.666666666666665e-01*G1_2_2_2_1 + 1.666666666666665e-01*G1_2_2_2_2 + 1.666666666666665e-01*G2_2_2_0_0 + 1.666666666666665e-01*G2_2_2_0_1 + 1.666666666666665e-01*G2_2_2_0_2 + 1.666666666666665e-01*G2_2_2_1_0 + 1.666666666666665e-01*G2_2_2_1_1 + 1.666666666666665e-01*G2_2_2_1_2 + 1.666666666666665e-01*G2_2_2_2_0 + 1.666666666666665e-01*G2_2_2_2_1 + 1.666666666666665e-01*G2_2_2_2_2 + 1.666666666666665e-01*G3_0_0 + 1.666666666666665e-01*G3_0_1 + 1.666666666666665e-01*G3_0_2 + 1.666666666666665e-01*G3_1_0 + 1.666666666666665e-01*G3_1_1 + 1.666666666666665e-01*G3_1_2 + 1.666666666666665e-01*G3_2_0 + 1.666666666666665e-01*G3_2_1 + 1.666666666666665e-01*G3_2_2;
    block[105] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_0_1 - 1.666666666666665e-01*G0_0_2 - 1.666666666666665e-01*G1_2_2_0_0 - 1.666666666666665e-01*G1_2_2_0_1 - 1.666666666666665e-01*G1_2_2_0_2 - 1.666666666666665e-01*G2_2_2_0_0 - 1.666666666666665e-01*G2_2_2_0_1 - 1.666666666666665e-01*G2_2_2_0_2 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_0_1 - 1.666666666666665e-01*G3_0_2;
    block[106] = -1.666666666666665e-01*G0_1_0 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G1_2_2_1_0 - 1.666666666666665e-01*G1_2_2_1_1 - 1.666666666666665e-01*G1_2_2_1_2 - 1.666666666666665e-01*G2_2_2_1_0 - 1.666666666666665e-01*G2_2_2_1_1 - 1.666666666666665e-01*G2_2_2_1_2 - 1.666666666666665e-01*G3_1_0 - 1.666666666666665e-01*G3_1_1 - 1.666666666666665e-01*G3_1_2;
    block[107] = -1.666666666666665e-01*G0_2_0 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G0_2_2 - 1.666666666666665e-01*G1_2_2_2_0 - 1.666666666666665e-01*G1_2_2_2_1 - 1.666666666666665e-01*G1_2_2_2_2 - 1.666666666666665e-01*G2_2_2_2_0 - 1.666666666666665e-01*G2_2_2_2_1 - 1.666666666666665e-01*G2_2_2_2_2 - 1.666666666666665e-01*G3_2_0 - 1.666666666666665e-01*G3_2_1 - 1.666666666666665e-01*G3_2_2;
    block[108] = -1.666666666666665e-01*G1_0_2_0_0 - 1.666666666666665e-01*G1_0_2_1_0 - 1.666666666666664e-01*G1_0_2_2_0 - 1.666666666666665e-01*G2_2_0_0_0 - 1.666666666666665e-01*G2_2_0_1_0 - 1.666666666666664e-01*G2_2_0_2_0;
    block[109] = 1.666666666666665e-01*G1_0_2_0_0 + 1.666666666666665e-01*G2_2_0_0_0;
    block[110] = 1.666666666666665e-01*G1_0_2_1_0 + 1.666666666666665e-01*G2_2_0_1_0;
    block[111] = 1.666666666666665e-01*G1_0_2_2_0 + 1.666666666666665e-01*G2_2_0_2_0;
    block[112] = -1.666666666666665e-01*G1_1_2_0_0 - 1.666666666666665e-01*G1_1_2_1_0 - 1.666666666666665e-01*G1_1_2_2_0 - 1.666666666666665e-01*G2_2_1_0_0 - 1.666666666666665e-01*G2_2_1_1_0 - 1.666666666666665e-01*G2_2_1_2_0;
    block[113] = 1.666666666666665e-01*G1_1_2_0_0 + 1.666666666666665e-01*G2_2_1_0_0;
    block[114] = 1.666666666666665e-01*G1_1_2_1_0 + 1.666666666666665e-01*G2_2_1_1_0;
    block[115] = 1.666666666666665e-01*G1_1_2_2_0 + 1.666666666666665e-01*G2_2_1_2_0;
    block[116] = -1.666666666666665e-01*G0_0_0 - 1.666666666666665e-01*G0_1_0 - 1.666666666666665e-01*G0_2_0 - 1.666666666666665e-01*G1_2_2_0_0 - 1.666666666666665e-01*G1_2_2_1_0 - 1.666666666666665e-01*G1_2_2_2_0 - 1.666666666666665e-01*G2_2_2_0_0 - 1.666666666666665e-01*G2_2_2_1_0 - 1.666666666666665e-01*G2_2_2_2_0 - 1.666666666666665e-01*G3_0_0 - 1.666666666666665e-01*G3_1_0 - 1.666666666666665e-01*G3_2_0;
    block[117] = 1.666666666666665e-01*G0_0_0 + 1.666666666666665e-01*G1_2_2_0_0 + 1.666666666666665e-01*G2_2_2_0_0 + 1.666666666666665e-01*G3_0_0;
    block[118] = 1.666666666666665e-01*G0_1_0 + 1.666666666666665e-01*G1_2_2_1_0 + 1.666666666666665e-01*G2_2_2_1_0 + 1.666666666666665e-01*G3_1_0;
    block[119] = 1.666666666666665e-01*G0_2_0 + 1.666666666666665e-01*G1_2_2_2_0 + 1.666666666666665e-01*G2_2_2_2_0 + 1.666666666666665e-01*G3_2_0;
    block[120] = -1.666666666666665e-01*G1_0_2_0_1 - 1.666666666666665e-01*G1_0_2_1_1 - 1.666666666666664e-01*G1_0_2_2_1 - 1.666666666666665e-01*G2_2_0_0_1 - 1.666666666666665e-01*G2_2_0_1_1 - 1.666666666666664e-01*G2_2_0_2_1;
    block[121] = 1.666666666666665e-01*G1_0_2_0_1 + 1.666666666666665e-01*G2_2_0_0_1;
    block[122] = 1.666666666666665e-01*G1_0_2_1_1 + 1.666666666666665e-01*G2_2_0_1_1;
    block[123] = 1.666666666666665e-01*G1_0_2_2_1 + 1.666666666666665e-01*G2_2_0_2_1;
    block[124] = -1.666666666666665e-01*G1_1_2_0_1 - 1.666666666666665e-01*G1_1_2_1_1 - 1.666666666666665e-01*G1_1_2_2_1 - 1.666666666666665e-01*G2_2_1_0_1 - 1.666666666666665e-01*G2_2_1_1_1 - 1.666666666666665e-01*G2_2_1_2_1;
    block[125] = 1.666666666666665e-01*G1_1_2_0_1 + 1.666666666666665e-01*G2_2_1_0_1;
    block[126] = 1.666666666666665e-01*G1_1_2_1_1 + 1.666666666666665e-01*G2_2_1_1_1;
    block[127] = 1.666666666666665e-01*G1_1_2_2_1 + 1.666666666666665e-01*G2_2_1_2_1;
    block[128] = -1.666666666666665e-01*G0_0_1 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G1_2_2_0_1 - 1.666666666666665e-01*G1_2_2_1_1 - 1.666666666666665e-01*G1_2_2_2_1 - 1.666666666666665e-01*G2_2_2_0_1 - 1.666666666666665e-01*G2_2_2_1_1 - 1.666666666666665e-01*G2_2_2_2_1 - 1.666666666666665e-01*G3_0_1 - 1.666666666666665e-01*G3_1_1 - 1.666666666666665e-01*G3_2_1;
    block[129] = 1.666666666666665e-01*G0_0_1 + 1.666666666666665e-01*G1_2_2_0_1 + 1.666666666666665e-01*G2_2_2_0_1 + 1.666666666666665e-01*G3_0_1;
    block[130] = 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G1_2_2_1_1 + 1.666666666666665e-01*G2_2_2_1_1 + 1.666666666666665e-01*G3_1_1;
    block[131] = 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G1_2_2_2_1 + 1.666666666666665e-01*G2_2_2_2_1 + 1.666666666666665e-01*G3_2_1;
    block[132] = -1.666666666666665e-01*G1_0_2_0_2 - 1.666666666666665e-01*G1_0_2_1_2 - 1.666666666666664e-01*G1_0_2_2_2 - 1.666666666666665e-01*G2_2_0_0_2 - 1.666666666666665e-01*G2_2_0_1_2 - 1.666666666666664e-01*G2_2_0_2_2;
    block[133] = 1.666666666666665e-01*G1_0_2_0_2 + 1.666666666666665e-01*G2_2_0_0_2;
    block[134] = 1.666666666666665e-01*G1_0_2_1_2 + 1.666666666666665e-01*G2_2_0_1_2;
    block[135] = 1.666666666666665e-01*G1_0_2_2_2 + 1.666666666666665e-01*G2_2_0_2_2;
    block[136] = -1.666666666666665e-01*G1_1_2_0_2 - 1.666666666666665e-01*G1_1_2_1_2 - 1.666666666666665e-01*G1_1_2_2_2 - 1.666666666666665e-01*G2_2_1_0_2 - 1.666666666666665e-01*G2_2_1_1_2 - 1.666666666666665e-01*G2_2_1_2_2;
    block[137] = 1.666666666666665e-01*G1_1_2_0_2 + 1.666666666666665e-01*G2_2_1_0_2;
    block[138] = 1.666666666666665e-01*G1_1_2_1_2 + 1.666666666666665e-01*G2_2_1_1_2;
    block[139] = 1.666666666666665e-01*G1_1_2_2_2 + 1.666666666666665e-01*G2_2_1_2_2;
    block[140] = -1.666666666666665e-01*G0_0_2 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G0_2_2 - 1.666666666666665e-01*G1_2_2_0_2 - 1.666666666666665e-01*G1_2_2_1_2 - 1.666666666666665e-01*G1_2_2_2_2 - 1.666666666666665e-01*G2_2_2_0_2 - 1.666666666666665e-01*G2_2_2_1_2 - 1.666666666666665e-01*G2_2_2_2_2 - 1.666666666666665e-01*G3_0_2 - 1.666666666666665e-01*G3_1_2 - 1.666666666666665e-01*G3_2_2;
    block[141] = 1.666666666666665e-01*G0_0_2 + 1.666666666666665e-01*G1_2_2_0_2 + 1.666666666666665e-01*G2_2_2_0_2 + 1.666666666666665e-01*G3_0_2;
    block[142] = 1.666666666666665e-01*G0_1_2 + 1.666666666666665e-01*G1_2_2_1_2 + 1.666666666666665e-01*G2_2_2_1_2 + 1.666666666666665e-01*G3_1_2;
    block[143] = 1.666666666666665e-01*G0_2_2 + 1.666666666666665e-01*G1_2_2_2_2 + 1.666666666666665e-01*G2_2_2_2_2 + 1.666666666666665e-01*G3_2_2;

    return true;
  }

};

} }

#endif
