// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.6.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __HEAT_H
#define __HEAT_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Heat {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm(const real& c0) : dolfin::BilinearForm(0), c0(c0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_ = det;
    real G1_0_0 = det*c0*(g00*g00 + g01*g01);
    real G1_0_1 = det*c0*(g00*g10 + g01*g11);
    real G1_1_0 = det*c0*(g10*g00 + g11*g01);
    real G1_1_1 = det*c0*(g10*g10 + g11*g11);

    // Compute element tensor
    block[0] = 8.333333333333318e-02*G0_ + 4.999999999999998e-01*G1_0_0 + 4.999999999999997e-01*G1_0_1 + 4.999999999999997e-01*G1_1_0 + 4.999999999999996e-01*G1_1_1;
    block[1] = 4.166666666666659e-02*G0_ - 4.999999999999998e-01*G1_0_0 - 4.999999999999997e-01*G1_0_1;
    block[2] = 4.166666666666658e-02*G0_ - 4.999999999999997e-01*G1_1_0 - 4.999999999999996e-01*G1_1_1;
    block[3] = 4.166666666666659e-02*G0_ - 4.999999999999998e-01*G1_0_0 - 4.999999999999997e-01*G1_1_0;
    block[4] = 8.333333333333318e-02*G0_ + 4.999999999999998e-01*G1_0_0;
    block[5] = 4.166666666666659e-02*G0_ + 4.999999999999997e-01*G1_1_0;
    block[6] = 4.166666666666658e-02*G0_ - 4.999999999999997e-01*G1_0_1 - 4.999999999999996e-01*G1_1_1;
    block[7] = 4.166666666666659e-02*G0_ + 4.999999999999997e-01*G1_0_1;
    block[8] = 8.333333333333316e-02*G0_ + 4.999999999999996e-01*G1_1_1;

    return true;
  }
        
private:

  const real& c0;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 3;
    }

    inline unsigned int shapedim() const
    {
      return 2;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, const real& c0) : dolfin::LinearForm(2), c0(c0)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_0 = det*w[0][0];
    real G0_1 = det*w[0][1];
    real G0_2 = det*w[0][2];
    real G1_0 = det*c0*w[1][0];
    real G1_1 = det*c0*w[1][1];
    real G1_2 = det*c0*w[1][2];

    // Compute element tensor
    block[0] = 8.333333333333318e-02*G0_0 + 4.166666666666659e-02*G0_1 + 4.166666666666658e-02*G0_2 + 8.333333333333318e-02*G1_0 + 4.166666666666659e-02*G1_1 + 4.166666666666658e-02*G1_2;
    block[1] = 4.166666666666659e-02*G0_0 + 8.333333333333318e-02*G0_1 + 4.166666666666659e-02*G0_2 + 4.166666666666659e-02*G1_0 + 8.333333333333318e-02*G1_1 + 4.166666666666659e-02*G1_2;
    block[2] = 4.166666666666658e-02*G0_0 + 4.166666666666659e-02*G0_1 + 8.333333333333316e-02*G0_2 + 4.166666666666658e-02*G1_0 + 4.166666666666659e-02*G1_1 + 8.333333333333316e-02*G1_2;

    return true;
  }
        
private:

  const real& c0;

};

} }

#endif
